<?php

namespace Drupal\Tests\devel_generate_commerce\Functional;

use Drupal\Tests\BrowserTestBase;
use Drupal\Tests\devel_generate\Traits\DevelGenerateSetupTrait;
use Drush\TestTraits\DrushTestTrait;

/**
 * Devel Generate Commerce Module Drush Command Test.
 *
 * @group devel_generate_commerce
 */
class CommerceDevelGenerateCommandTest extends BrowserTestBase {

  use DrushTestTrait;
  use DevelGenerateSetupTrait;

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stable';

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['node', 'block', 'devel_generate_commerce'];

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();
    $this->drupalPlaceBlock('page_title_block');
  }

  /**
   * Tests generating commerce entities via drush.
   */
  public function testDrushGenerateCommand() {

    // Creates commerce entities With out Kill Option.
    $options = [
      'products_num' => 55,
      'kill' => NULL,
    ];
    $this->drush('devel-generate:commerce', $options);
    $commerce_entities = \Drupal::entityQuery('commerce')->accessCheck(TRUE)->execute();
    $this->assertCount(55, $commerce_entities);
    $messages = $this->getErrorOutput();
    $this->assertStringContainsStringIgnoringCase('Finished 55 elements created successfully.', $messages, 'devel-generate:commerce batch ending message not found');

  }

}
